<?php
// add main page
$page['header'] = LBL_ADD;
$page['crumbs'][] = 'teams';
$page['content'] = '';

$group_name = array_key_exists('group_name', $_POST) ? stripslashes($_POST['group_name']) : NULL;
$group_descr = array_key_exists('group_descr', $_POST) ? substr(stripslashes($_POST['group_descr']), 0, 254) : NULL;
$control = array_key_exists('control', $_POST) ? $_POST['control'] : NULL;
$group_vis = array_key_exists('group_vis', $_POST) ? $_POST['group_vis'] : 'yes';

//if ($_POST) $page['content'] .= "<pre>" . print_r($_POST, true) . "</pre>";
if ($control == LBL_ADD_FORM_ACTION) {
  $forbidden = array('"', '<' , '>' , '/' , '\\', '*', ':');
  $new_name = str_replace($forbidden, "", substr($group_name, 0, 75));
  if ($new_name != $group_name) {
    //$page['messages'][] = "new: $new_name, old: $group_name";
    $group_name = $new_name;
    $page['errors'][] = ERROR_GROUPER_INVALIDNAME;
    unset($control);
  }
  if (strlen($new_name) < 6) {
    $page['errors'][] = ERROR_GROUPER_INVALIDNAME_SHORT;
    unset($control);
  }
/*
  $forbidden = array('<' , '>' , '/' , '\\');
  $new_name = str_replace($forbidden, "", substr($group_descr, 0, 254));
  if ($new_name != $group_descr) {
    $group_descr = $new_name;
  }
*/
  if (isset($control)) { // If control is still set, the name should be ok.
    $gr = new_grouper();
    if (!$gr->isConnected()) {
      $page['errors'][] = ERROR_GROUPER_CONNECT;
      return;
    }

    $new_id = str_replace(" ", "_", $new_name);
    $new_id = str_replace("'", "", $new_id);
    $new_id = strtolower($new_id);

    $group = $gr->getGroup($grouper['stem'] . ":" . $new_id);
    if (count($group) > 0) {
      $page['errors'][] = ERROR_GROUPER_INVALIDNAME_EXISTS;
      unset($control);
    }
  }
}

if (empty($control)) {
  $page['content'] .= LBL_ADD_CONTENT;
  $page['content'] .= "<form method='post' name='addform'>\n";
  $page['content'] .= "<table class='find'>\n";
  $page['content'] .= "<tr><td>" . LBL_ADD_FORM_NAME . "</td><td><input name='group_name' type=text value='" . htmlspecialchars($group_name, ENT_QUOTES) . "' size='41'></td><td>" . LBL_ADD_FORM_NAME_COMMENT . "</td></tr>\n";
  $page['content'] .= "<tr><td>" . LBL_ADD_FORM_DESCR . "</td><td><textarea name='group_descr' cols='40'>" . htmlspecialchars($group_descr, ENT_QUOTES) . "</textarea></td><td>" . LBL_ADD_FORM_DESCR_COMMENT . "</td></tr>\n";
  $page['content'] .= "<tr><td>" . LBL_ADD_FORM_VIS . "</td>";
  $page['content'] .= "<td><input name='group_vis' type='radio' value='yes'" . ($group_vis == 'yes'?' checked':'') . "> " . LBL_ADD_FORM_VIS_YES;
  $page['content'] .= " <input name='group_vis' type='radio' value='no'" . ($group_vis == 'no'?' checked':'') . "> " . LBL_ADD_FORM_VIS_NO . "</td>";
  $page['content'] .= "<td></td></tr>\n";
  $page['content'] .= "<tr><td></td><td><input type='submit' name='control' value='" . LBL_ADD_FORM_ACTION . "'></td></tr>\n";
  $page['content'] .= "</table>\n";
  $page['content'] .= "</form>\n";

} else if ($control == LBL_ADD_FORM_ACTION) {
/*
  $gr = new_grouper();
  if (!$gr->isConnected()) {
    $page['errors'][] = ERROR_GROUPER_CONNECT;
    return;
  }
*/
  $new_group = $gr->addGroup($group_name, $group_descr);
  if ($new_group == -1) {
    $page['content'] .= ERROR_GROUPER_ADDGROUP;
    return;
  }
  
  $set_admin = $gr->setPrivilege($new_group['id'], $uuid, 'admin', TRUE);
  $set_update = $gr->setPrivilege($new_group['id'], $uuid, 'update', TRUE);
  $set_optout = $gr->setPrivilege($new_group['id'], $uuid, 'optout', TRUE);
  if (!($set_admin && $set_update && $set_optout)) {
    $page['content'] .= ERROR_GROUPER_SETPRIVILEGES;
    return;
  }
  
  if (!$gr->addMember($new_group['id'], $uuid, $uuid)) {
    $page['content'] .= ERROR_GROUPER_ADDMEMBER;
  	return;
  }
  
  $set_visible = $gr->setPrivilege($new_group['id'], 'GrouperAll', 'view', ($group_vis == 'yes'));
  if (!$set_visible) {
    $page['content'] .= ERROR_GROUPER_SETPRIVILEGES;
    return;
  }
  
//  $page['content'] .= LBL_ADD_SUCCESS;
//  $page['content'] .= "<pre>" . print_r($new_group, true) . "</pre>\n";
  $page['content'] .= "<form method='post' action='invite' name='redirect'>\n";
  $page['content'] .= "<input type=hidden name='group_id' value='" . $new_group['id'] . "'>\n";
  $page['content'] .= "</form>\n";
  $page['content'] .= "<script>document.forms.redirect.submit();</script>\n";
}

?>
